package com.mins01.jwschat;

import org.json.simple.JSONObject;
import org.json.simple.JSONValue;

public class ChatMsg {
	JSONObject jsonobj = new JSONObject();
	public ChatMsg(){
		
	}
	public ChatMsg(String raw){
		decode(raw);
	}
	public void input(String rawjson){
		jsonobj = (JSONObject) JSONValue.parse(rawjson);
	}
	@SuppressWarnings("unchecked")
	public void put(String k, Object v) {
		jsonobj.put(k,v);
	}
	public String toString(){
		return jsonobj.toJSONString();
	}
	public void setR(String v) {
		put("r",v);
	}
	public void setCmd(String v) {
		put("cmd",v);
	}	
	public void setData(Object v) {
		put("data",v);
	}
	public void set(Object data, String cmd) {
		clear();
		setData(data);
		setCmd(cmd);
	}
	public void set(Object data) {
		clear();
		setData(data);
	}
	public void setUser(User usr) {
		put("nick",usr.nick);
	}
	public Object get(String k) {
		return jsonobj.get(k);
	}
	@SuppressWarnings("unchecked")
	public void decode(String raw) {
		JSONObject jsonobj2 = (JSONObject) JSONValue.parse(raw);
		jsonobj.putAll(jsonobj2);
	}
	
	public void clear() {
		jsonobj.clear();
	}
	
	
}
