if(!jwschat){
	var jwschat = {};
}

jwschat.client = {
	 "ws":null
	,"init":function(){
		
	}
	,"createForm":function(roomName){

	}
	,"exitRoom":function(roomName){
	}
	,"isSuppoertedWebSocket":function(){
		if(window.WebSocket || "WebSocket" in window){
			return true;
		}
		return false;
	}
	,"connect":function(uri){
		if(!this.isSuppoertedWebSocket()){
			alert("웹 소캣이 지원되지 않는 브라우저입니다.")
			return false;
		}
		this.ws = new WebSocket(uri);
		//this.ws = new WebSocket("ws://210.92.76.13:6001");
		this.ws.onopen = function(){ jwschat.client._onopen.apply(jwschat.client,arguments);}
		this.ws.onmessage = function(){ jwschat.client._onmessage.apply(jwschat.client,arguments);}
		this.ws.onclose = function(){ jwschat.client._onclose.apply(jwschat.client,arguments);}
		this.ws.onerror = function(){ jwschat.client._onerror.apply(jwschat.client,arguments);}
	}
	,"onopen":function(e){
		
	}
	,"onmessage":function(e){
		
	}
	,"onclose":function(e){
		
	}	
	,"onerror":function(e){
		
	}		
	,"_onopen":function(evt){
		if(!this.ws) return false;
		log("[WebSocket->onopen]\n");
		this.onopen(evt);
	}
	,"_onmessage":function(evt){
		if(!this.ws) return false;
		log(evt.data);
		var res = JSON.parse(evt.data);
		this.processCmd(res);
		this.onmessage(evt);
	}
	,"_onclose":function(evt){
		//log(e.type);
		log("연결이 끊어졌습니다.");
		alert("연결이 끊어졌습니다.");
		//this.showMsg("onclose");
		//alert("onclose");
		this.ws = null;
		this.onclose(evt);
	}
	,"_onerror":function(evt){
		//var errorMsg ="[error]["+evt.code+"]"+evt.reason; //현재 지원 안됨
		var errorMsg = "[error]에러가 발생되었습니다.";
		log(errorMsg);
		alert(errorMsg);
		this.onerror(evt);
		this.ws.close();
		//this.ws = null;
		
	}	
	,"sendFromForm":function(f){
		var cm = {};
		cm.r = f.r.value;
		cm.data = f.msg.value;
		client.sendCm(cm);
		f.msg.value="";
		f.msg.focus();
	}
	,"sendCm":function(cm){
		client.sendRaw(JSON.stringify(cm));
	}	
	,"sendRaw":function(msg){
		if(!this.ws) return false;
		this.ws.send(msg);
	}
	,"processCmd":function(res){
		if(!res.cmd || res.cmd.length < 0){
			res.cmd = 'showMsg';
		}
		if(!this[res.cmd]){
			alert(res.cmd+" : 지원되지 않는 명령입니다.");
			log(res.cmd+" : 지원되지 않는 명령입니다.");
			return false;
		}
		this[res.cmd](res);
		
	}
	,"showMsg":function(res){
		ui.rooms.showMsg(res);
	}
	,"alert":function(res){
		ui.rooms.alert(res);
	}
	,"syncUserlist":function(res){
		ui.rooms.syncUserlist(res);
		/*
		ui.rooms.joinRoom(res);
		var userlist = res.data
		var f = this.forms[res.r];
		if(!f){alert(res.r+"해당 채팅 창이 없습니다."); return false;}
		var ul = f.userlist;
		ul.length = 0;
		if(userlist.length==0){
			ul.options.add(new Option("NONE","",false,false));	
		}else{
			for(var i=0,m=userlist.length;i<m;i++){
				ul.options.add(new Option(userlist[i],userlist[i],false,false));
			}
		}
		*/
	}
	,"syncRoomlist":function(res){
		ui.roomlist.syncRoomlist(res.data);
	}
	,"syncJoinedRoomlist":function(res){
		ui.roomlist.syncJoinedRoomlist(res.data);
	}
	,"joinRoom":function(res){
		ui.rooms.joinRoom(res);
	}
	,"changeNick":function(res){
		ui.roomlist.changeNick(res);
	}
	,"setNick":function(res){
		ui.roomlist.setNick(res);
	}
	
	
}