var ui = {}
/**
 * 입장 부분
 */
ui.gate ={
	"divGate":null
	,"divChatRoom":null
	,"init":function(){
		this.divGate = document.getElementById("divGate");
		this.divChatRoom = document.getElementById("divChatRoom");
		
		this.hide();
	}
	,"show":function(){
		this.divGate.style.display="block";
		this.divChatRoom.style.display="none";
	}
	,"hide":function(){
		this.divGate.style.display="none";
		this.divChatRoom.style.display="block";
	}
	,"actEnter":function(uri){
		this.onactenter(uri);
	}
	,"onactenter":function(uri){
		//재설정되야함
	}
}
/**
 * 
 */
ui.roomlist ={
	"divRoomlist":null
	,"ulRoomlist":null
	,"ulRoomBar":null
	,"roombars":{}
	,"init":function(){
		this.divRoomlist = document.getElementById("room-_divRoomlist");
		this.ulRoomlist = document.getElementById("ulRoomlist");
		this.ulRoomBar = document.getElementById("ulRoomBar");
		
		this.hide();
	}
	,"show":function(){
		this.divRoomlist.style.display="block";
	}
	,"hide":function(){
		this.divRoomlist.style.display="none";
	}
	,"syncRoomlist":function(roomlist){
		this.ulRoomlist.innerHTML = "";
		var defLi = _M.DOM.create('li');
		var defBtn = _M.DOM.create('input');defBtn.type="button";
		for(var i=0,m=roomlist.length;i<m;i++){
			var li = defLi.cloneNode(true);
			var btn = defBtn.cloneNode(true);
			btn.onclick = function(){
				ui.roomlist.actJoinRoom(this.value);
			}
			btn.value=roomlist[i];
			li.appendChild(btn);
			this.ulRoomlist.appendChild(li);
		}
		//this.syncRoomBar(roomlist);
	}
	,"syncJoinedRoomlist":function(roomlist){
		var lis = _M.DOM.byTagName("li",ulRoomBar);
		var li;
		while(li = lis[2]){
			_M.DOM.remove(li);
		}
		this.roombars = {};
		this.roombars['_divRoomlist'] = lis[0];
		this.roombars['_divConfig'] = lis[1];
		
		var defLi = _M.DOM.create('li');
		var defBtn = _M.DOM.create('input');defBtn.type="button";
		
		for(var i=0,m=roomlist.length;i<m;i++){
			var li = defLi.cloneNode(true);
			//li.id="li-room-"+roomlist[i];
			var btn = defBtn.cloneNode(true);
			btn.onclick = function(){
				ui.roomlist.showRoom(this.value);
			}
			btn.value=roomlist[i];
			li.appendChild(btn);
			this.roombars[roomlist[i]] = li;
			this.ulRoomBar.appendChild(li);
		}
	}
	,"focus":function(roonName){
		var lis = this.ulRoomBar.getElementsByTagName('li');
		for(var i=0,m=lis.length;i<m;i++){
			lis[i].className = "";
		}
		if(this.roombars[roonName]){
			this.roombars[roonName].className = "on";
		}
	}
	,"showRoom":function(roomName){
		var id = 'room-'+roomName;
		var typeRooms = document.getElementsByClassName("type-room");
		for(var i=0,m=typeRooms.length;i<m;i++){
			typeRooms[i].style.display="none";
		}
		var d = _M.DOM.byId(id);
		d.style.display="";
		
		ui.rooms.focus(roomName);
		ui.roomlist.focus(roomName);
	}
	,"actSyncRoomList":function(){
		var cm = {};
		cm.cmd = "syncRoomlist";
		cm.data = "";
		jwschat.client.sendCm(cm);
	}
	,"actSyncJoinedRoomlist":function(){
		var cm = {};
		cm.cmd = "syncJoinedRoomlist";
		cm.data = "";
		jwschat.client.sendCm(cm);
	}
	,"actJoinRoom":function(roomName){
		var cm = {};
		cm.cmd = "joinRoom";
		cm.data = roomName;
		jwschat.client.sendCm(cm);
	}
	,"joinRoom":function(res){
		ui.rooms.joinRoom(res);
	}
	,"actExitRoom":function(res){
		var cm = {};
		cm.cmd = "exitRoom";
		cm.data = roomName;
		jwschat.client.sendCm(cm);
	}
	,"exitRoom":function(res){
		ui.rooms.rextRoom(res);
	}
	,"actChangeNick":function(nick){
		var cm = {};
		cm.cmd = "changeNick";
		cm.data = nick;
		jwschat.client.sendCm(cm);
	}
	,"changeNick":function(res){
		this.setNick(res);
	}
	,"setNick":function(res){
		var iptNicks = document.getElementsByClassName("type-nick");
		for(var i=0,m=iptNicks.length;i<m;i++){
			iptNicks[i].value = res.data;
		}
	}	
}

ui.rooms = {
	"rooms":{}
	,"defRoom":null
	,"divRooms":null
	,"init":function(){
		this.divRooms = document.getElementById("divRooms");
		this.defRoom = _M.DOM.byId('defRoom');
		this.defRoom.id = "";
	}	
	,"joinRoom":function(res){
		if(this.rooms[res.r]){
			ui.roomlist.showRoom(res.r);
			return
		}		
		this.rooms[res.r] = new ui.Room();
		this.rooms[res.r].init(this.defRoom.cloneNode(true),res);
		this.divRooms.appendChild(this.rooms[res.r].box);
		this.rooms[res.r].focus();
		ui.roomlist.showRoom(res.r);
	}
	,"focus":function(roomName){
		if(!roomName || !this.rooms[roomName]){return;}
		this.rooms[roomName].focus();
	}
	,"actJoinRoom":function(roomName){
		var cm = {};
		cm.cmd = "joinRoom";
		cm.data = roomName;
		jwschat.client.sendCm(cm);
	}	
	,"exitRoom":function(r){
		if(!this.rooms[r]){alert(r+"해당 채팅 창이 없습니다.(exitRoom)"); return false;}
		var p = this.rooms[r].box.parentNode;
		p.removeChild(p);
		ui.roomlist.showRoom('_divRoomlist');
	}
	,"showMsg":function(res){
		if(!this.rooms[res.r]){alert(res.r+"해당 채팅 창이 없습니다.(showMsg)"); return false;}
		this.rooms[res.r].showMsg(res);
	}
	,"syncUserlist":function(res){
		if(!this.rooms[res.r]){alert(res.r+"해당 채팅 창이 없습니다.(syncUserlist)"); return false;}
		this.rooms[res.r].syncUserlist(res);
	}
	,"alert":function(res){
		alert(res.data);
	}
}

ui.Room = function(){
}
ui.Room.prototype = {
	 "box":null
	,"form":null
	,"msg":null
	,"r":null
	,"userlist":null
	,"ul_view":null
	,"init":function(box,res){
		this.box = box;
		this.box.id = 'room-'+res.r;
		this.form = _M.DOM.byTagName("form",box)[0];
		this.msg = this.form.msg;
		this.r =  this.form.r;
		this.userlist =  this.form.userlist;
		this.ul_view = box.getElementsByClassName("ul_view")[0];
		this.chatView = box.getElementsByClassName("chat-view")[0];
		this.r.value = res.r;
		this.clearMsg(0);
		
	}
	,"showMsg":function(res){
		var msg = res.data;
		var nick = res.nick;
		
		var li = _M.DOM.create('li');
		li.appendChild(_M.DOM.createText(nick+":"+msg));
		this.ul_view.appendChild(li);
		this.chatView.scrollTop =this.chatView.scrollHeight;
		this.clearMsg(100);
	}
	,"clearMsg":function(limit){
		var lis = this.chatView.getElementsByTagName('li');
		var i = lis.length-limit-1;
		for(;i>-1;i--){
			lis[i].parentNode.removeChild(lis[i]);
		}
	}
	,"syncUserlist":function(res){
		var userlist = res.data;
		var ul = this.userlist;
		ul.length = 0;
		if(userlist.length==0){
			ul.options.add(new Option("NONE","",false,false));	
		}else{
			for(var i=0,m=userlist.length;i<m;i++){
				ul.options.add(new Option(userlist[i],userlist[i],false,false));
			}
		}
	}
	,"focus":function(){
		this.msg.focus();
	}
	
}
